#!/bin/sh

if [ -x /usr/bin/uname ];
then
        if [ `/usr/bin/uname` = "FreeBSD" ]; then
                I_AM_FREEBSD=1
                echo "detected FreeBSD, will install from ports"
        fi
fi

if [ ! $I_AM_FREEBSD ]; 
then
#        /usr/bin/perl -MCPAN -e 'use CPAN; CPAN::install LWP; CPAN::install RPC::XML; CPAN::install SOAP::Lite; CPAN::install DBI; CPAN::install DBD::mysql; CPAN::install Apache::DBI; CPAN::install Apache2::SOAP'
        exit
fi

GREP="/usr/bin/grep"
PKG_INFO="/usr/sbin/pkg_info"
PKG_ADD="/usr/sbin/pkg_add"
PORTSNAP="/usr/sbin/portsnap"

if [ -x PORTSNAP ];   # FreeBSD 6 
then
    $PORTSNAP fetch
    $PORTSNAP update
else
    PORTSNAP="/usr/local/sbin/portsnap"
    if [ -x PORTSNAP ];   # FreeBSD < 6 with portsnap port installed
    then
        $PORTSNAP fetch
        $PORTSNAP update
    fi
fi

if [ -z "`$PKG_INFO | $GREP perl-`" ]; then
    echo "installing perl"
    $PKG_ADD -r perl

    # if pkg_add -r fails, try to build from ports
    if [ -z "`$PKG_INFO | $GREP perl`" ]; then
        echo "installing Perl"
        cd /usr/ports/lang/perl5.8 && make install distclean
    fi
else
        echo "Perl is installed."
fi

if [ -z "`$PKG_INFO | $GREP rrdtool`" ]; then
    echo "installing rrdtool"
    cd /usr/ports/net/rrdtool && make install distclean
else
        echo "rrdtool is installed."
fi

if [ -z "`$PKG_INFO | $GREP p5-TimeDate`" ]; then
    echo "installing Date::Format"
    cd /usr/ports/devel/p5-TimeDate && make install distclean
else
        echo "Date::Format is installed."
fi

if [ -z "`$PKG_INFO | $GREP net-snmp`" ]; then
    echo "installing snmpd 5"
    cd /usr/ports/net-mgmt/net-snmp && make install distclean
else
        echo "net-snmp is installed."
fi

if [ -z "`$PKG_INFO | $GREP p5-Net-SNMP`" ]; then
    echo "installing Net::SNMP"
    cd /usr/ports/net-mgmt/p5-Net-SNMP && make install distclean
else
        echo "Net::SNMP is installed."
fi
